<?php

/**
 * Implements hook_rules_action_info()
 */
function radioactivity_rules_action_info() {
  $defaults = array(
    'parameter' => array(
      'data' => array(
        'type' => '*',
        'label' => t('Radioactivity field'),
        'description' => t('The radioactivity field in which you want to add an incident to'),
        'restriction' => 'selector',
        'wrapped' => TRUE,
        'allow null' => TRUE,
      ),
      'value' => array(
        'type' => '*',
        'label' => t('Energy'),
        'description' => t('The variable which contains the amount of energy to be added to or substracted from the field'),
        'allow null' => TRUE,
        'optional' => TRUE,
      ),
    ),
    'group' => t('Radioactivity'),
    'access callback' => 'rules_user_integration_access',
  );

  $items['radioactivity_emit'] = $defaults + array(
    'label' => t('Add an incident'),
    'base' => 'radioactivity_rules_action_emit',
  );

  return $items;
}


/**
 * Action: Emit energy
 */
function radioactivity_rules_action_emit($field, $energy) {
 
  $info = $field->info();

  $field_name = $info['name']; 
  $entity_type = $info['parent']->type();
  $bundle = $info['parent']->getBundle(); 
  $id = $info['parent']->getIdentifier();
  $lang = LANGUAGE_NONE;
 
  if ($info['translatable']) {
    global $language;
    $lang = $language->language;
  } 

  $profile = radioctivity_get_field_profile($entity_type, $bundle, $field_name);
  if ($profile && $profile->storageObject) {
    $profile->storageObject->addIncident(new RadioactivityIncident($entity_type, $bundle, $field_name, $lang, $id, $energy, time()));
  }
  field_cache_clear();
}


/**
 * User integration access callback.
 */
function radioactivity_rules_integration_access($type, $name) {
  return user_access('administer radioactivity');
}


